Index: Makefile.am
===================================================================
--- Makefile.am	(revision 363)
+++ Makefile.am	(revision 321)
@@ -1,5 +1,3 @@
 ACLOCAL_AMFLAGS = -I m4
-
-AM_CXXFLAGS = $(WARNINGCXXFLAGS)
 
 AM_CPPFLAGS = -I$(top_srcdir) -I$(top_builddir)
Index: configure.ac
===================================================================
--- configure.ac	(revision 363)
+++ configure.ac	(revision 310)
@@ -19,4 +19,6 @@
 AC_CONFIG_SRCDIR([lemon/list_graph.h])
 AC_CONFIG_HEADERS([config.h lemon/config.h])
+
+lx_cmdline_cxxflags_set=${CXXFLAGS+set}
 
 dnl Do compilation tests using the C++ compiler.
@@ -45,8 +47,7 @@
 
 dnl Set custom compiler flags when using g++.
-if test "$GXX" = yes -a "$ICC" = no; then
-  WARNINGCXXFLAGS="-Wall -W -Wall -W -Wunused -Wformat=2 -Wctor-dtor-privacy -Wnon-virtual-dtor -Wno-char-subscripts -Wwrite-strings -Wno-char-subscripts -Wreturn-type -Wcast-qual -Wcast-align -Wsign-promo -Woverloaded-virtual -ansi -fno-strict-aliasing -Wold-style-cast -Wno-unknown-pragmas"
+if test x"$lx_cmdline_cxxflags_set" != x"set" -a "$GXX" = yes -a "$ICC" = no; then
+  CXXFLAGS="$CXXFLAGS -Wall -W -Wall -W -Wunused -Wformat=2 -Wctor-dtor-privacy -Wnon-virtual-dtor -Wno-char-subscripts -Wwrite-strings -Wno-char-subscripts -Wreturn-type -Wcast-qual -Wcast-align -Wsign-promo -Woverloaded-virtual -Woverloaded-virtual -ansi -fno-strict-aliasing -Wold-style-cast -Wno-unknown-pragmas"
 fi
-AC_SUBST([WARNINGCXXFLAGS])
 
 dnl Checks for libraries.
@@ -113,5 +114,5 @@
 echo
 echo C++ compiler.................. : $CXX
-echo C++ compiles flags............ : $WARNINGCXXFLAGS $CXXFLAGS
+echo C++ compiles flags............ : $CXXFLAGS
 echo
 #echo GLPK support.................. : $lx_glpk_found
Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 363)
+++ lemon/Makefile.am	(revision 364)
@@ -13,5 +13,5 @@
         lemon/random.cc
 
-#lemon_libemon_la_CXXFLAGS = $(GLPK_CFLAGS) $(CPLEX_CFLAGS) $(SOPLEX_CXXFLAGS) $(AM_CXXFLAGS)
+#lemon_libemon_la_CXXFLAGS = $(GLPK_CFLAGS) $(CPLEX_CFLAGS) $(SOPLEX_CXXFLAGS)
 #lemon_libemon_la_LDFLAGS = $(GLPK_LIBS) $(CPLEX_LIBS) $(SOPLEX_LIBS)
 
@@ -32,4 +32,5 @@
         lemon/graph_to_eps.h \
         lemon/grid_graph.h \
+	lemon/hypercube_graph.h \
 	lemon/kruskal.h \
 	lemon/lgf_reader.h \
Index: lemon/bits/alteration_notifier.h
===================================================================
--- lemon/bits/alteration_notifier.h	(revision 361)
+++ lemon/bits/alteration_notifier.h	(revision 314)
@@ -36,60 +36,59 @@
   // a container.
   //
-  // The simple graphs can be refered as two containers: a node container
-  // and an edge container. But they do not store values directly, they
-  // are just key continars for more value containers, which are the
-  // node and edge maps.
-  //
-  // The node and edge sets of the graphs can be changed as we add or erase
+  // The simple graph's can be refered as two containers, one node container
+  // and one edge container. But they are not standard containers they
+  // does not store values directly they are just key continars for more
+  // value containers which are the node and edge maps.
+  //
+  // The graph's node and edge sets can be changed as we add or erase
   // nodes and edges in the graph. LEMON would like to handle easily
   // that the node and edge maps should contain values for all nodes or
   // edges. If we want to check on every indicing if the map contains
   // the current indicing key that cause a drawback in the performance
-  // in the library. We use another solution: we notify all maps about
+  // in the library. We use another solution we notify all maps about
   // an alteration in the graph, which cause only drawback on the
   // alteration of the graph.
   //
-  // This class provides an interface to a node or edge container.
-  // The first() and next() member functions make possible
-  // to iterate on the keys of the container.
-  // The id() function returns an integer id for each key.
-  // The maxId() function gives back an upper bound of the ids.
+  // This class provides an interface to the container. The \e first() and \e
+  // next() member functions make possible to iterate on the keys of the
+  // container. The \e id() function returns an integer id for each key.
+  // The \e maxId() function gives back an upper bound of the ids.
   //
   // For the proper functonality of this class, we should notify it
-  // about each alteration in the container. The alterations have four type:
-  // add(), erase(), build() and clear(). The add() and
-  // erase() signal that only one or few items added or erased to or
-  // from the graph. If all items are erased from the graph or if a new graph
-  // is built from an empty graph, then it can be signaled with the
+  // about each alteration in the container. The alterations have four type
+  // as \e add(), \e erase(), \e build() and \e clear(). The \e add() and
+  // \e erase() signals that only one or few items added or erased to or
+  // from the graph. If all items are erased from the graph or from an empty
+  // graph a new graph is builded then it can be signaled with the
   // clear() and build() members. Important rule that if we erase items
-  // from graphs we should first signal the alteration and after that erase
+  // from graph we should first signal the alteration and after that erase
   // them from the container, on the other way on item addition we should
   // first extend the container and just after that signal the alteration.
   //
   // The alteration can be observed with a class inherited from the
-  // ObserverBase nested class. The signals can be handled with
+  // \e ObserverBase nested class. The signals can be handled with
   // overriding the virtual functions defined in the base class.  The
   // observer base can be attached to the notifier with the
-  // attach() member and can be detached with detach() function. The
+  // \e attach() member and can be detached with detach() function. The
   // alteration handlers should not call any function which signals
   // an other alteration in the same notifier and should not
   // detach any observer from the notifier.
   //
-  // Alteration observers try to be exception safe. If an add() or
-  // a clear() function throws an exception then the remaining
+  // Alteration observers try to be exception safe. If an \e add() or
+  // a \e clear() function throws an exception then the remaining
   // observeres will not be notified and the fulfilled additions will
-  // be rolled back by calling the erase() or clear() functions.
-  // Hence erase() and clear() should not throw exception.
-  // Actullay, they can throw only \ref ImmediateDetach exception,
-  // which detach the observer from the notifier.
-  //
-  // There are some cases, when the alteration observing is not completly
+  // be rolled back by calling the \e erase() or \e clear()
+  // functions. Thence the \e erase() and \e clear() should not throw
+  // exception. Actullay, it can be throw only \ref ImmediateDetach
+  // exception which detach the observer from the notifier.
+  //
+  // There are some place when the alteration observing is not completly
   // reliable. If we want to carry out the node degree in the graph
-  // as in the \ref InDegMap and we use the reverseArc(), then it cause
+  // as in the \ref InDegMap and we use the reverseEdge that cause
   // unreliable functionality. Because the alteration observing signals
-  // only erasing and adding but not the reversing, it will stores bad
-  // degrees. Apart form that the subgraph adaptors cannot even signal
-  // the alterations because just a setting in the filter map can modify
-  // the graph and this cannot be watched in any way.
+  // only erasing and adding but not the reversing it will stores bad
+  // degrees. The sub graph adaptors cannot signal the alterations because
+  // just a setting in the filter map can modify the graph and this cannot
+  // be watched in any way.
   //
   // \param _Container The container which is observed.
@@ -105,11 +104,11 @@
     typedef _Item Item;
 
-    // \brief Exception which can be called from clear() and
-    // erase().
-    //
-    // From the clear() and erase() function only this
+    // \brief Exception which can be called from \e clear() and
+    // \e erase().
+    //
+    // From the \e clear() and \e erase() function only this
     // exception is allowed to throw. The exception immediatly
     // detaches the current observer from the notifier. Because the
-    // clear() and erase() should not throw other exceptions
+    // \e clear() and \e erase() should not throw other exceptions
     // it can be used to invalidate the observer.
     struct ImmediateDetach {};
@@ -123,5 +122,6 @@
     // The observer interface contains some pure virtual functions
     // to override. The add() and erase() functions are
-    // to notify the oberver when one item is added or erased.
+    // to notify the oberver when one item is added or
+    // erased.
     //
     // The build() and clear() members are to notify the observer
Index: lemon/bits/array_map.h
===================================================================
--- lemon/bits/array_map.h	(revision 361)
+++ lemon/bits/array_map.h	(revision 314)
@@ -37,9 +37,10 @@
   // \brief Graph map based on the array storage.
   //
-  // The ArrayMap template class is graph map structure that automatically
-  // updates the map when a key is added to or erased from the graph.
-  // This map uses the allocators to implement the container functionality.
+  // The ArrayMap template class is graph map structure what
+  // automatically updates the map when a key is added to or erased from
+  // the map. This map uses the allocators to implement
+  // the container functionality.
   //
-  // The template parameters are the Graph, the current Item type and
+  // The template parameters are the Graph the current Item type and
   // the Value type of the map.
   template <typename _Graph, typename _Item, typename _Value>
@@ -47,12 +48,12 @@
     : public ItemSetTraits<_Graph, _Item>::ItemNotifier::ObserverBase {
   public:
-    // The graph type.
+    // The graph type of the maps.
     typedef _Graph Graph;
-    // The item type.
+    // The item type of the map.
     typedef _Item Item;
     // The reference map tag.
     typedef True ReferenceMapTag;
 
-    // The key type of the map.
+    // The key type of the maps.
     typedef _Item Key;
     // The value type of the map.
@@ -200,5 +201,5 @@
     // \brief Adds a new key to the map.
     //
-    // It adds a new key to the map. It is called by the observer notifier
+    // It adds a new key to the map. It called by the observer notifier
     // and it overrides the add() member function of the observer base.
     virtual void add(const Key& key) {
@@ -228,5 +229,5 @@
     // \brief Adds more new keys to the map.
     //
-    // It adds more new keys to the map. It is called by the observer notifier
+    // It adds more new keys to the map. It called by the observer notifier
     // and it overrides the add() member function of the observer base.
     virtual void add(const std::vector<Key>& keys) {
@@ -272,5 +273,5 @@
     // \brief Erase a key from the map.
     //
-    // Erase a key from the map. It is called by the observer notifier
+    // Erase a key from the map. It called by the observer notifier
     // and it overrides the erase() member function of the observer base.
     virtual void erase(const Key& key) {
@@ -281,5 +282,5 @@
     // \brief Erase more keys from the map.
     //
-    // Erase more keys from the map. It is called by the observer notifier
+    // Erase more keys from the map. It called by the observer notifier
     // and it overrides the erase() member function of the observer base.
     virtual void erase(const std::vector<Key>& keys) {
@@ -290,7 +291,7 @@
     }
 
-    // \brief Builds the map.
-    //
-    // It builds the map. It is called by the observer notifier
+    // \brief Buildes the map.
+    //
+    // It buildes the map. It called by the observer notifier
     // and it overrides the build() member function of the observer base.
     virtual void build() {
@@ -306,5 +307,5 @@
     // \brief Clear the map.
     //
-    // It erase all items from the map. It is called by the observer notifier
+    // It erase all items from the map. It called by the observer notifier
     // and it overrides the clear() member function of the observer base.
     virtual void clear() {
Index: lemon/bits/base_extender.h
===================================================================
--- lemon/bits/base_extender.h	(revision 361)
+++ lemon/bits/base_extender.h	(revision 314)
@@ -31,5 +31,5 @@
 //\ingroup digraphbits
 //\file
-//\brief Extenders for the graph types
+//\brief Extenders for the digraph types
 namespace lemon {
 
Index: lemon/bits/graph_extender.h
===================================================================
--- lemon/bits/graph_extender.h	(revision 361)
+++ lemon/bits/graph_extender.h	(revision 314)
@@ -30,10 +30,10 @@
 //\ingroup graphbits
 //\file
-//\brief Extenders for the graph types
+//\brief Extenders for the digraph types
 namespace lemon {
 
   // \ingroup graphbits
   //
-  // \brief Extender for the digraph implementations
+  // \brief Extender for the Digraphs
   template <typename Base>
   class DigraphExtender : public Base {
Index: lemon/bits/traits.h
===================================================================
--- lemon/bits/traits.h	(revision 360)
+++ lemon/bits/traits.h	(revision 314)
@@ -219,17 +219,4 @@
 
   template <typename Graph, typename Enable = void>
-  struct ArcNumTagIndicator {
-    static const bool value = false;
-  };
-
-  template <typename Graph>
-  struct ArcNumTagIndicator<
-    Graph,
-    typename enable_if<typename Graph::ArcNumTag, void>::type
-  > {
-    static const bool value = true;
-  };
-
-  template <typename Graph, typename Enable = void>
   struct EdgeNumTagIndicator {
     static const bool value = false;
@@ -245,17 +232,4 @@
 
   template <typename Graph, typename Enable = void>
-  struct FindArcTagIndicator {
-    static const bool value = false;
-  };
-
-  template <typename Graph>
-  struct FindArcTagIndicator<
-    Graph,
-    typename enable_if<typename Graph::FindArcTag, void>::type
-  > {
-    static const bool value = true;
-  };
-
-  template <typename Graph, typename Enable = void>
   struct FindEdgeTagIndicator {
     static const bool value = false;
Index: lemon/bits/vector_map.h
===================================================================
--- lemon/bits/vector_map.h	(revision 361)
+++ lemon/bits/vector_map.h	(revision 314)
@@ -39,7 +39,7 @@
   // \brief Graph map based on the std::vector storage.
   //
-  // The VectorMap template class is graph map structure that automatically
-  // updates the map when a key is added to or erased from the graph.
-  // This map type uses std::vector to store the values.
+  // The VectorMap template class is graph map structure what
+  // automatically updates the map when a key is added to or erased from
+  // the map. This map type uses the std::vector to store the values.
   //
   // \tparam _Graph The graph this map is attached to.
@@ -170,5 +170,5 @@
     // \brief Adds a new key to the map.
     //
-    // It adds a new key to the map. It is called by the observer notifier
+    // It adds a new key to the map. It called by the observer notifier
     // and it overrides the add() member function of the observer base.
     virtual void add(const Key& key) {
@@ -181,5 +181,5 @@
     // \brief Adds more new keys to the map.
     //
-    // It adds more new keys to the map. It is called by the observer notifier
+    // It adds more new keys to the map. It called by the observer notifier
     // and it overrides the add() member function of the observer base.
     virtual void add(const std::vector<Key>& keys) {
@@ -196,5 +196,5 @@
     // \brief Erase a key from the map.
     //
-    // Erase a key from the map. It is called by the observer notifier
+    // Erase a key from the map. It called by the observer notifier
     // and it overrides the erase() member function of the observer base.
     virtual void erase(const Key& key) {
@@ -204,5 +204,5 @@
     // \brief Erase more keys from the map.
     //
-    // It erases more keys from the map. It is called by the observer notifier
+    // Erase more keys from the map. It called by the observer notifier
     // and it overrides the erase() member function of the observer base.
     virtual void erase(const std::vector<Key>& keys) {
@@ -212,7 +212,7 @@
     }
 
-    // \brief Build the map.
-    //
-    // It builds the map. It is called by the observer notifier
+    // \brief Buildes the map.
+    //
+    // It buildes the map. It called by the observer notifier
     // and it overrides the build() member function of the observer base.
     virtual void build() {
@@ -224,5 +224,5 @@
     // \brief Clear the map.
     //
-    // It erases all items from the map. It is called by the observer notifier
+    // It erase all items from the map. It called by the observer notifier
     // and it overrides the clear() member function of the observer base.
     virtual void clear() {
Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 360)
+++ lemon/full_graph.h	(revision 355)
@@ -307,5 +307,4 @@
 
     typedef True NodeNumTag;
-    typedef True ArcNumTag;
     typedef True EdgeNumTag;
 
@@ -345,5 +344,4 @@
 
     typedef True FindEdgeTag;
-    typedef True FindArcTag;
 
     Edge findEdge(Node u, Node v, Edge prev = INVALID) const {
Index: lemon/grid_graph.h
===================================================================
--- lemon/grid_graph.h	(revision 360)
+++ lemon/grid_graph.h	(revision 338)
@@ -83,5 +83,4 @@
 
     typedef True NodeNumTag;
-    typedef True EdgeNumTag;
     typedef True ArcNumTag;
 
@@ -129,5 +128,4 @@
 
     typedef True FindEdgeTag;
-    typedef True FindArcTag;
 
     Edge findEdge(Node u, Node v, Edge prev = INVALID) const {
Index: lemon/hypercube_graph.h
===================================================================
--- lemon/hypercube_graph.h	(revision 364)
+++ lemon/hypercube_graph.h	(revision 364)
@@ -0,0 +1,316 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef HYPERCUBE_GRAPH_H
+#define HYPERCUBE_GRAPH_H
+
+#include <iostream>
+#include <vector>
+#include <lemon/core.h>
+#include <lemon/error.h>
+
+#include <lemon/bits/base_extender.h>
+#include <lemon/bits/graph_extender.h>
+
+///\ingroup graphs
+///\file
+///\brief HypercubeDigraph class.
+
+namespace lemon {
+
+  class HypercubeDigraphBase {
+
+  public:
+
+    typedef HypercubeDigraphBase Digraph;
+
+    class Node;
+    class Arc;
+
+  public:
+
+    HypercubeDigraphBase() {}
+
+  protected:
+
+    void construct(int dim) {
+      _dim = dim;
+      _nodeNum = 1 << dim;
+    }
+
+  public:
+
+    typedef True NodeNumTag;
+    typedef True ArcNumTag;
+
+    int nodeNum() const { return _nodeNum; }
+    int arcNum() const { return _nodeNum * _dim; }
+
+    int maxNodeId() const { return nodeNum() - 1; }
+    int maxArcId() const { return arcNum() - 1; }
+
+    Node source(Arc e) const {
+      return e.id / _dim;
+    }
+
+    Node target(Arc e) const {
+      return (e.id / _dim) ^ (1 << (e.id % _dim));
+    }
+
+    static int id(Node v) { return v.id; }
+    static int id(Arc e) { return e.id; }
+
+    static Node nodeFromId(int id) { return Node(id); }
+
+    static Arc arcFromId(int id) { return Arc(id); }
+
+    class Node {
+      friend class HypercubeDigraphBase;
+    protected:
+      int id;
+      Node(int _id) { id = _id;}
+    public:
+      Node() {}
+      Node (Invalid) { id = -1; }
+      bool operator==(const Node node) const { return id == node.id; }
+      bool operator!=(const Node node) const { return id != node.id; }
+      bool operator<(const Node node) const { return id < node.id; }
+    };
+
+    class Arc {
+      friend class HypercubeDigraphBase;
+    protected:
+      int id;
+      Arc(int _id) : id(_id) {}
+    public:
+      Arc() { }
+      Arc (Invalid) { id = -1; }
+      bool operator==(const Arc arc) const { return id == arc.id; }
+      bool operator!=(const Arc arc) const { return id != arc.id; }
+      bool operator<(const Arc arc) const { return id < arc.id; }
+    };
+
+    void first(Node& node) const {
+      node.id = nodeNum() - 1;
+    }
+
+    static void next(Node& node) {
+      --node.id;
+    }
+
+    void first(Arc& arc) const {
+      arc.id = arcNum() - 1;
+    }
+
+    static void next(Arc& arc) {
+      --arc.id;
+    }
+
+    void firstOut(Arc& arc, const Node& node) const {
+      arc.id = node.id * _dim;
+    }
+
+    void nextOut(Arc& arc) const {
+      ++arc.id;
+      if (arc.id % _dim == 0) arc.id = -1;
+    }
+
+    void firstIn(Arc& arc, const Node& node) const {
+      arc.id = (node.id ^ 1) * _dim;
+    }
+
+    void nextIn(Arc& arc) const {
+      int cnt = arc.id % _dim;
+      if ((cnt + 1) % _dim == 0) {
+        arc.id = -1;
+      } else {
+        arc.id = ((arc.id / _dim) ^ ((1 << cnt) * 3)) * _dim + cnt + 1;
+      }
+    }
+
+    int dimension() const {
+      return _dim;
+    }
+
+    bool projection(Node node, int n) const {
+      return static_cast<bool>(node.id & (1 << n));
+    }
+
+    int dimension(Arc arc) const {
+      return arc.id % _dim;
+    }
+
+    int index(Node node) const {
+      return node.id;
+    }
+
+    Node operator()(int ix) const {
+      return Node(ix);
+    }
+
+  private:
+    int _dim, _nodeNum;
+  };
+
+
+  typedef DigraphExtender<HypercubeDigraphBase> ExtendedHypercubeDigraphBase;
+
+  /// \ingroup digraphs
+  ///
+  /// \brief Hypercube digraph class
+  ///
+  /// This class implements a special digraph type. The nodes of the
+  /// digraph are indiced with integers with at most \c dim binary digits.
+  /// Two nodes are connected in the digraph if the indices differ only
+  /// on one position in the binary form.
+  ///
+  /// \note The type of the \c ids is chosen to \c int because efficiency
+  /// reasons. Thus the maximum dimension of this implementation is 26.
+  ///
+  /// The digraph type is fully conform to the \ref concepts::Digraph
+  /// concept but it does not conform to \ref concepts::Graph.
+  class HypercubeDigraph : public ExtendedHypercubeDigraphBase {
+  public:
+
+    typedef ExtendedHypercubeDigraphBase Parent;
+
+    /// \brief Construct a hypercube digraph with \c dim dimension.
+    ///
+    /// Construct a hypercube digraph with \c dim dimension.
+    HypercubeDigraph(int dim) { construct(dim); }
+
+    /// \brief Gives back the number of the dimensions.
+    ///
+    /// Gives back the number of the dimensions.
+    int dimension() const {
+      return Parent::dimension();
+    }
+
+    /// \brief Returns true if the n'th bit of the node is one.
+    ///
+    /// Returns true if the n'th bit of the node is one.
+    bool projection(Node node, int n) const {
+      return Parent::projection(node, n);
+    }
+
+    /// \brief The dimension id of the arc.
+    ///
+    /// It returns the dimension id of the arc. It can
+    /// be in the \f$ \{0, 1, \dots, dim-1\} \f$ interval.
+    int dimension(Arc arc) const {
+      return Parent::dimension(arc);
+    }
+
+    /// \brief Gives back the index of the node.
+    ///
+    /// Gives back the index of the node. The lower bits of the
+    /// integer describes the node.
+    int index(Node node) const {
+      return Parent::index(node);
+    }
+
+    /// \brief Gives back the node by its index.
+    ///
+    /// Gives back the node by its index.
+    Node operator()(int ix) const {
+      return Parent::operator()(ix);
+    }
+
+    /// \brief Number of nodes.
+    int nodeNum() const { return Parent::nodeNum(); }
+    /// \brief Number of arcs.
+    int arcNum() const { return Parent::arcNum(); }
+
+    /// \brief Linear combination map.
+    ///
+    /// It makes possible to give back a linear combination
+    /// for each node. This function works like the \c std::accumulate
+    /// so it accumulates the \c bf binary function with the \c fv
+    /// first value. The map accumulates only on that dimensions where
+    /// the node's index is one. The accumulated values should be
+    /// given by the \c begin and \c end iterators and the length of this
+    /// range should be equal to the dimension number of the digraph.
+    ///
+    ///\code
+    /// const int DIM = 3;
+    /// HypercubeDigraph digraph(DIM);
+    /// dim2::Point<double> base[DIM];
+    /// for (int k = 0; k < DIM; ++k) {
+    ///   base[k].x = rnd();
+    ///   base[k].y = rnd();
+    /// }
+    /// HypercubeDigraph::HyperMap<dim2::Point<double> >
+    ///   pos(digraph, base, base + DIM, dim2::Point<double>(0.0, 0.0));
+    ///\endcode
+    ///
+    /// \see HypercubeDigraph
+    template <typename T, typename BF = std::plus<T> >
+    class HyperMap {
+    public:
+
+      typedef Node Key;
+      typedef T Value;
+
+
+      /// \brief Constructor for HyperMap.
+      ///
+      /// Construct a HyperMap for the given digraph. The accumulated values
+      /// should be given by the \c begin and \c end iterators and the length
+      /// of this range should be equal to the dimension number of the digraph.
+      ///
+      /// This function accumulates the \c bf binary function with
+      /// the \c fv first value. The map accumulates only on that dimensions
+      /// where the node's index is one.
+      template <typename It>
+      HyperMap(const Digraph& digraph, It begin, It end,
+               T fv = 0.0, const BF& bf = BF())
+        : _graph(digraph), _values(begin, end), _first_value(fv), _bin_func(bf)
+      {
+        LEMON_ASSERT(_values.size() == digraph.dimension(),
+                     "Wrong size of dimension");
+      }
+
+      /// \brief Gives back the partial accumulated value.
+      ///
+      /// Gives back the partial accumulated value.
+      Value operator[](Key k) const {
+        Value val = _first_value;
+        int id = _graph.index(k);
+        int n = 0;
+        while (id != 0) {
+          if (id & 1) {
+            val = _bin_func(val, _values[n]);
+          }
+          id >>= 1;
+          ++n;
+        }
+        return val;
+      }
+
+    private:
+      const Digraph& _graph;
+      std::vector<T> _values;
+      T _first_value;
+      BF _bin_func;
+    };
+
+  };
+
+}
+
+#endif
Index: lemon/nauty_reader.h
===================================================================
--- lemon/nauty_reader.h	(revision 359)
+++ lemon/nauty_reader.h	(revision 352)
@@ -39,5 +39,5 @@
   /// general, connected, biconnected, triangle-free, 4-cycle-free,
   /// bipartite and graphs with given edge number and degree
-  /// constraints). This function reads a \e nauty \e graph6 \e format
+  /// constraints). This function reads a \e nauty \e graph \e format
   /// line from the given stream and builds it in the given graph.
   ///
@@ -49,5 +49,5 @@
   /// int num = 0;
   /// SmartGraph graph;
-  /// while (readNautyGraph(graph, std::cin)) {
+  /// while (readNauty(graph, std::cin)) {
   ///   PlanarityChecking<SmartGraph> pc(graph);
   ///   if (pc.run()) ++num;
@@ -62,5 +62,5 @@
   ///\endcode
   template <typename Graph>
-  std::istream& readNautyGraph(Graph& graph, std::istream& is = std::cin) {
+  std::istream& readNauty(Graph& graph, std::istream& is = std::cin) {
     graph.clear();
 
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 360)
+++ lemon/smart_graph.h	(revision 329)
@@ -68,5 +68,5 @@
 
     typedef True NodeNumTag;
-    typedef True ArcNumTag;
+    typedef True EdgeNumTag;
 
     int nodeNum() const { return nodes.size(); }
Index: test/digraph_test.cc
===================================================================
--- test/digraph_test.cc	(revision 354)
+++ test/digraph_test.cc	(revision 364)
@@ -21,5 +21,5 @@
 #include <lemon/smart_graph.h>
 #include <lemon/full_graph.h>
-//#include <lemon/hypercube_graph.h>
+#include <lemon/hypercube_graph.h>
 
 #include "test_tools.h"
@@ -113,4 +113,33 @@
 }
 
+void checkHypercubeDigraph(int dim) {
+  DIGRAPH_TYPEDEFS(HypercubeDigraph);
+
+  HypercubeDigraph G(dim);
+  checkGraphNodeList(G, 1 << dim);
+  checkGraphArcList(G, (1 << dim) * dim);
+
+  Node n = G.nodeFromId(dim);
+
+  checkGraphOutArcList(G, n, dim);
+  for (OutArcIt a(G, n); a != INVALID; ++a)
+    check(G.source(a) == n &&
+          G.id(G.target(a)) == G.id(n) ^ (1 << G.dimension(a)),
+          "Wrong arc");
+
+  checkGraphInArcList(G, n, dim);
+  for (InArcIt a(G, n); a != INVALID; ++a)
+    check(G.target(a) == n &&
+          G.id(G.source(a)) == G.id(n) ^ (1 << G.dimension(a)),
+          "Wrong arc");
+
+  checkGraphConArcList(G, (1 << dim) * dim);
+
+  checkNodeIds(G);
+  checkArcIds(G);
+  checkGraphNodeMap(G);
+  checkGraphArcMap(G);
+}
+
 
 void checkConcepts() {
@@ -146,7 +175,7 @@
     checkConcept<Digraph, FullDigraph>();
   }
-//  { // Checking HyperCubeDigraph
-//    checkConcept<Digraph, HyperCubeDigraph>();
-//  }
+  { // Checking HypercubeDigraph
+    checkConcept<Digraph, HypercubeDigraph>();
+  }
 }
 
@@ -213,4 +242,10 @@
     checkFullDigraph(8);
   }
+  { // Checking HypercubeDigraph
+    checkHypercubeDigraph(1);
+    checkHypercubeDigraph(2);
+    checkHypercubeDigraph(3);
+    checkHypercubeDigraph(4);
+  }
 }
 
Index: tools/lemon-0.x-to-1.x.sh
===================================================================
--- tools/lemon-0.x-to-1.x.sh	(revision 359)
+++ tools/lemon-0.x-to-1.x.sh	(revision 344)
@@ -91,5 +91,4 @@
         -e "s/\<storeBoolMap\>/loggerBoolMap/g"\
         -e "s/\<BoundingBox\>/Box/g"\
-        -e "s/\<readNauty\>/readNautyGraph/g"\
     <$i > $TMP
     mv $TMP $i